Subject: Re: [PATCH v2 08/12] ARM: dts: imx6dl-pico: fix board compatibles

From: Krzysztof Kozlowski <[email-masked]>
Date: Thu, 1 Oct 2020 12:37:04 +0200

On Thu, Oct 01, 2020 at 12:19:08PM +0200, Ahmad Fatoum wrote:
> Hi,
> 
> On 10/1/20 9:32 AM, Krzysztof Kozlowski wrote:
> > On Thu, Oct 01, 2020 at 09:22:03AM +0200, Ahmad Fatoum wrote:
> >>> diff --git a/arch/arm/boot/dts/imx6dl-pico-hobbit.dts b/arch/arm/boot/dts/imx6dl-pico-hobbit.dts
> >>> index d7403c5c4337..08fedcbcc91b 100644
> >>> --- a/arch/arm/boot/dts/imx6dl-pico-hobbit.dts
> >>> +++ b/arch/arm/boot/dts/imx6dl-pico-hobbit.dts
> >>> @@ -13,5 +13,5 @@
> >>>  
> >>>  / {
> >>>  	model = "TechNexion PICO-IMX6 DualLite/Solo Board and Hobbit baseboard";
> >>> -	compatible = "technexion,imx6dl-pico", "fsl,imx6dl";
> >>> +	compatible = "technexion,imx6dl-pico-hobbit", "fsl,imx6dl";
> >>>  };
> > 
> > The bindings, added in commit 53b61224ca40 ("dt-bindings: arm: fsl: Add
> > TechNexion boards"), describe that these are the only valid compatibles.
> > "technexion,imx6dl-pico" is not valid and would require changing the
> > bindings, thus breaking compatibility which you want to avoid.> 
> > The bindings, not what is present in DTS, is considered ABI.
> 
> The existing binding doesn't cover these boards then and needs to be
> extended, no? How about following patch?

What do you mean it doesn't cover? It was added exactly to handle them:
+              - technexion,imx6q-pico-dwarf   # TechNexion i.MX6Q Pico-Dwarf
+              - technexion,imx6q-pico-hobbit  # TechNexion i.MX6Q Pico-Hobbit
+              - technexion,imx6q-pico-nymph   # TechNexion i.MX6Q Pico-Nymph
+              - technexion,imx6q-pico-pi      # TechNexion i.MX6Q Pico-Pi

> 
> [I guess we need to keep the two-compatible list they were originally
>  in for compatibility even if it's unused among upstream device trees?]

You want to change both the binding (thus breaking the ABI) and update
the DTS to reflect new ABI. Then why having a binding at all?

I would assume that either binding is correct or DTS. You propose that
both are wrong and both need changes... in such case this is clearly
broken.

Best regards,
Krzysztof

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel